import es
import playerlib
import os
import modellib

oldweps = {}
oldteams = {}
downloadlist = {}
classlist = {}
indexlist = {}
useridlist = {}
steamidlist = {}
teamlist = {}

#Config
resolveteams = { "#t": 2, "#ct": 3, "2": 2, "3": 3 }
WorldModelUserid = False
NadeModels = False
#End Config

def player_disconnect(ev):
	userid = int(ev["userid"])
	if userid in oldweps:
		del oldweps[userid]
	if userid in oldteams:
		del oldteams[userid]
	if userid in useridlist:
		for classname in useridlist[userid]:
			if classname == "player":
				delplayeruserid(userid)
			else:
				delweaponuserid(userid,classname)

def player_activate(ev):
	userid = int(ev["userid"])
	steamid = ev["es_steamid"]
	if steamid in steamidlist:
		for classname in steamidlist[steamid]:
			if classname == "player":
				addplayeruserid(userid,steamidlist[steamid]["player"])
			else:
				addweaponuserid(userid,classname,steamidlist[steamid][classname]["world"],steamidlist[steamid][classname]["view"])

def player_spawn(ev):
	userid = int(ev["userid"])
	if userid in useridlist:
		if "player" in useridlist[userid]:
			setPlayerModel(userid, useridlist[userid]["player"])

def checkmodelstring(model):
	if model.startswith("models\\") or model.startswith("models/"):
		model = model[7:]
	if not model.endswith(".mdl"):
		model += ".mdl"
	return model

def setPlayerModel(userid, model):
	if model == "-1" or not useridexists(userid) or isdead(userid):
		return
	model = checkmodelstring(model)
	index = es.precachemodel("models/%s" % model)
	if index < 1:
		es.dbgmsg(0, "ModelChanger: Unable to precache model 'models/%s'" % model)
		return
	es.setplayerprop(userid, "CBaseEntity.m_nModelIndex", index)
	es.setplayerprop(userid, "CBaseEntity.m_clrRender", -1)

def setWorldModel(entity, model):	
	if model == "-1" or not indexexists(entity):
		return
	model = checkmodelstring(model)
	index = es.precachemodel("models/%s" % model)
	if index < 1:
		es.dbgmsg(0, "ModelChanger: Unable to precache model 'models/%s'" % model)
		return
	es.setindexprop(entity, "CBaseCombatWeapon.m_iWorldModelIndex", index)
	es.setindexprop(entity, "CBaseEntity.m_clrRender", -1)

def setEntityModel(entity, model):	
	if model == "-1" or not indexexists(entity):
		return
	model = checkmodelstring(model)
	index = es.precachemodel("models/%s" % model)
	if index < 1:
		es.dbgmsg(0, "ModelChanger: Unable to precache model 'models/%s'" % model)
		return
	es.setindexprop(entity, "CBaseEntity.m_nModelIndex", index)
	es.setindexprop(entity, "CBaseEntity.m_clrRender", -1)

def setActiveViewModel(userid, model):
	if model == "-1" or not useridexists(userid) or isdead(userid):
		return
	model = checkmodelstring(model)
	index = es.precachemodel("models/%s" % model)
	if index < 1:
		es.dbgmsg(0, "ModelChanger: Unable to precache model 'models/%s'" % model)
		return
	viewModelEnt = "predicted_viewmodel"
	gamename = str(es.ServerVar("eventscripts_gamedir")).replace("\\", "/").rpartition("/")[2].lower()
	if gamename == "tf":
		viewModelEnt = "tf_viewmodel"
	viewModelweaponindex = getActiveViewModelweaponindex(userid,viewModelEnt)
	if viewModelweaponindex < 1:
		es.dbgmsg(0, "ModelChanger: Unable to get a viewmodel index")
		return
	es.setindexprop(viewModelweaponindex, "CBaseViewModel.m_nModelIndex", index)

def getActiveViewModelweaponindex(userid,viewModelEntity):
	playerHandle = es.getplayerhandle(userid)
	entityList = es.createentitylist(viewModelEntity)
	for index in entityList:
		if es.getindexprop(index, "CBaseViewModel.m_hOwner") != playerHandle:
			continue
		if es.getplayerprop(userid, "CBaseCombatCharacter.m_hActiveWeapon") != es.getindexprop(index, "CBaseViewModel.m_hWeapon"):
			continue
		return index
	return -1

def load():
	if es.exists("command","mc_addweaponclass") == 0:
		es.regcmd("mc_addweaponclass", "modelchanger/addweaponclasshandler", "This adds a weapon class")
	if es.exists("command","mc_addweaponindex") == 0:
		es.regcmd("mc_addweaponindex", "modelchanger/addweaponindexhandler", "This adds an weapon index")
	if es.exists("command","mc_addweaponuserid") == 0:
		es.regcmd("mc_addweaponuserid", "modelchanger/addweaponuseridhandler", "This adds a weapon userid")
	if es.exists("command","mc_addweaponsteamid") == 0:
		es.regcmd("mc_addweaponsteamid", "modelchanger/addweaponsteamidhandler", "This adds a weapon steamid")
	if es.exists("command","mc_addweaponteam") == 0:
		es.regcmd("mc_addweaponteam", "modelchanger/addweaponteamhandler", "This adds a weapon team")
	if es.exists("command","mc_addplayeruserid") == 0:
		es.regcmd("mc_addplayeruserid", "modelchanger/addplayeruseridhandler", "This adds a player userid")
	if es.exists("command","mc_addplayersteamid") == 0:
		es.regcmd("mc_addplayersteamid", "modelchanger/addplayersteamidhandler", "This adds a player steamid")
	if es.exists("command","mc_addplayerteam") == 0:
		es.regcmd("mc_addplayerteam", "modelchanger/addplayerteamhandler", "This adds a player team")
	if es.exists("command","mc_delweaponclass") == 0:
		es.regcmd("mc_delweaponclass", "modelchanger/delweaponclasshandler", "This removes a weapon class")
	if es.exists("command","mc_delweaponindex") == 0:
		es.regcmd("mc_delweaponindex", "modelchanger/delweaponindexhandler", "This removes an weapon index")
	if es.exists("command","mc_delweaponuserid") == 0:
		es.regcmd("mc_delweaponuserid", "modelchanger/delweaponuseridhandler", "This removes a weapon userid")
	if es.exists("command","mc_delweaponsteamid") == 0:
		es.regcmd("mc_delweaponsteamid", "modelchanger/delweaponsteamidhandler", "This removes a weapon steamid")
	if es.exists("command","mc_delweaponteam") == 0:
		es.regcmd("mc_delweaponteam", "modelchanger/delweaponteamhandler", "This removes a weapon team")
	if es.exists("command","mc_delplayeruserid") == 0:
		es.regcmd("mc_delplayeruserid", "modelchanger/delplayeruseridhandler", "This removes a player userid")
	if es.exists("command","mc_delplayersteamid") == 0:
		es.regcmd("mc_delplayersteamid", "modelchanger/delplayersteamidhandler", "This removes a player steamid")
	if es.exists("command","mc_delplayerteam") == 0:
		es.regcmd("mc_delplayerteam", "modelchanger/delplayerteamhandler", "This removes a player team")
	es.addons.registerTickListener(ticker)

def unload():
	es.addons.unregisterTickListener(ticker)

def addweaponclasshandler():
	if es.getargc() > 3:
		classname = es.getargv(1)
		worldmodel = es.getargv(2)
		viewmodel = es.getargv(3)
		addweaponclass(classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: mc_addweaponclass <classname> <worldmodel> <viewmodel>")

def addweaponindexhandler():
	if es.getargc() > 3:
		index = int(es.getargv(1))
		worldmodel = es.getargv(2)
		viewmodel = es.getargv(3)
		addweaponindex(index,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: mc_addweaponindex <index> <worldmodel> <viewmodel>")

def addweaponuseridhandler():
	if es.getargc() > 4:
		userid = int(es.getargv(1))
		classname = es.getargv(2)
		worldmodel = es.getargv(3)
		viewmodel = es.getargv(4)
		addweaponuserid(userid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: mc_addweaponuserid <userid> <class> <worldmodel> <viewmodel>")

def addweaponsteamidhandler():
	if es.getargc() > 4:
		steamid = es.getargv(1)
		classname = es.getargv(2)
		worldmodel = es.getargv(3)
		viewmodel = es.getargv(4)
		addweaponsteamid(steamid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: mc_addweaponsteamid <steamid> <class> <worldmodel> <viewmodel>")

def addweaponteamhandler():
	if es.getargc() > 4:
		team = es.getargv(1)
		classname = es.getargv(2)
		worldmodel = es.getargv(3)
		viewmodel = es.getargv(4)
		addweaponteam(team,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: mc_addweaponteam <team> <class> <worldmodel> <viewmodel>")

def addplayeruseridhandler():
	if es.getargc() > 2:
		userid = int(es.getargv(1))
		model = es.getargv(2)
		addplayeruserid(userid,model)
	else:
		es.dbgmsg(0, "Syntax: mc_addplayeruserid <userid> <model>")

def addplayersteamidhandler():
	if es.getargc() > 2:
		steamid = es.getargv(1)
		model = es.getargv(2)
		addplayersteamid(steamid,model)
	else:
		es.dbgmsg(0, "Syntax: mc_addplayersteamid <steamid> <model>")

def addplayerteamhandler():
	if es.getargc() > 2:
		team = es.getargv(1)
		model = es.getargv(2)
		addplayerteam(team,model)
	else:
		es.dbgmsg(0, "Syntax: mc_addplayerteam <team> <model>")

def delweaponclasshandler():
	if es.getargc() > 1:
		classname = es.getargv(1)
		delweaponclass(classname)
	else:
		es.dbgmsg(0, "Syntax: mc_delweaponclass <classname>")

def delweaponindexhandler():
	if es.getargc() > 1:
		index = int(es.getargv(1))
		delweaponindex(index)
	else:
		es.dbgmsg(0, "Syntax: mc_delweaponindex <index>")

def delweaponuseridhandler():
	if es.getargc() > 2:
		userid = int(es.getargv(1))
		classname = es.getargv(2)
		delweaponuserid(userid,classname)
	else:
		es.dbgmsg(0, "Syntax: mc_delweaponuserid <userid> <classname>")

def delweaponsteamidhandler():
	if es.getargc() > 1:
		steamid = es.getargv(1)
		classname = es.getargv(2)
		delweaponsteamid(steamid,classname)
	else:
		es.dbgmsg(0, "Syntax: mc_delweaponsteamid <steamid> <classname>")

def delweaponteamhandler():
	if es.getargc() > 1:
		team = es.getargv(1)
		classname = es.getargv(2)
		delweaponteam(team,classname)
	else:
		es.dbgmsg(0, "Syntax: mc_delweaponteam <team> <classname>")

def delplayeruseridhandler():
	if es.getargc() > 1:
		userid = int(es.getargv(1))
		delplayeruserid(userid)
	else:
		es.dbgmsg(0, "Syntax: mc_delplayeruserid <userid>")

def delplayersteamidhandler():
	if es.getargc() > 1:
		steamid = es.getargv(1)
		delplayersteamid(steamid)
	else:
		es.dbgmsg(0, "Syntax: mc_delplayersteamid <steamid>")

def delplayerteamhandler():
	if es.getargc() > 1:
		team = es.getargv(1)
		delplayerteam(team)
	else:
		es.dbgmsg(0, "Syntax: mc_delplayerteam <team>")

def addweaponclass(classname,worldmodel,viewmodel):
	if not classname in classlist:
		addmodeldownload(worldmodel)
		addmodeldownload(viewmodel)
		classlist[classname] = {}
		classlist[classname]["world"] = worldmodel
		classlist[classname]["view"] = viewmodel
		for index in es.createentitylist(classname):
			setWorldModel(index,worldmodel)
		for userid in es.getUseridList():
			if classname == getactiveweaponname(userid):
				setActiveViewModel(userid,viewmodel)
	else:
		es.dbgmsg(0, "addweaponclass: Specified class already exists. Cannot add.")

def addweaponindex(index,worldmodel,viewmodel):
	if not index in indexlist:
		addmodeldownload(worldmodel)
		addmodeldownload(viewmodel)
		indexlist[index] = {}
		indexlist[index]["world"] = worldmodel
		indexlist[index]["view"] = viewmodel
		setWorldModel(index,worldmodel)
		for userid in es.getUseridList():
			if index == getweaponindex(userid,getactiveweaponname(userid)):
				setActiveViewModel(userid,viewmodel)
	else:
		es.dbgmsg(0, "addweaponindex: Specified index already exists. Cannot add.")

def addweaponuserid(userid,classname,worldmodel,viewmodel):
	if not userid in useridlist:
		useridlist[userid] = {}
	if not classname in useridlist[userid]:
		addmodeldownload(worldmodel)
		addmodeldownload(viewmodel)
		useridlist[userid][classname] = {}
		useridlist[userid][classname]["world"] = worldmodel
		useridlist[userid][classname]["view"] = viewmodel
		if classname == getactiveweaponname(userid):
			setActiveViewModel(userid,viewmodel)
			index = getweaponindex(userid,classname)
			setWorldModel(index,worldmodel)
	else:
		es.dbgmsg(0, "addweaponuserid: Specified userid with classname already exists. Cannot add.")

def addweaponsteamid(steamid,classname,worldmodel,viewmodel):
	if not steamid in steamidlist:
		steamidlist[steamid] = {}
	if not classname in steamidlist[steamid]:
		addmodeldownload(worldmodel)
		addmodeldownload(viewmodel)
		steamidlist[steamid][classname] = {}
		steamidlist[steamid][classname]["world"] = worldmodel
		steamidlist[steamid][classname]["view"] = viewmodel
		userid = int(es.getuserid(steamid))
		addweaponuserid(userid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "addweaponsteamid: Specified steamid with classname already exists. Cannot add.")

def addweaponteam(team,classname,worldmodel,viewmodel):
	if not team in resolveteams:
		es.dbgmsg(0, "addweaponteam: Invalid team specified '%s'"%team)
		return
	team = resolveteams[team]
	if not team in teamlist:
		teamlist[team] = {}
	if not classname in teamlist[team]:
		addmodeldownload(worldmodel)
		addmodeldownload(viewmodel)
		teamlist[team][classname] = {}
		teamlist[team][classname]["world"] = worldmodel
		teamlist[team][classname]["view"] = viewmodel
		for userid in es.getUseridList():
			if es.getplayerprop(userid, "CBaseEntity.m_iTeamNum") == team:
				addweaponuserid(userid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "addweaponteam: Specified team with classname already exists. Cannot add.")

def addplayeruserid(userid,model):
	if not userid in useridlist:
		useridlist[userid] = {}
	if not "player" in useridlist[userid]:
		addmodeldownload(model)
		useridlist[userid]["player"] = model
		setPlayerModel(userid, model)
	else:
		es.dbgmsg(0, "addplayeruserid: Specified userid with player model already exists. Cannot add.")

def addplayersteamid(steamid,model):
	if not steamid in steamidlist:
		steamidlist[steamid] = {}
	if not "player" in steamidlist[steamid]:
		steamidlist[steamid]["player"] = model
		addmodeldownload(model)
		userid = int(es.getuserid(steamid))
		addplayeruserid(userid,model)
	else:
		es.dbgmsg(0, "addplayersteamid: Specified steamid with player model already exists. Cannot add.")

def addplayerteam(team,model):
	if not team in resolveteams:
		es.dbgmsg(0, "addplayerteam: Invalid team specified '%s'"%team)
		return
	team = resolveteams[team]
	if not team in teamlist:
		teamlist[team] = {}
	if not "player" in teamlist[team]:
		addmodeldownload(model)
		teamlist[team]["player"] = model
		for userid in es.getUseridList():
			if es.getplayerprop(userid, "CBaseEntity.m_iTeamNum") == team:
				addplayeruserid(userid,model)
	else:
		es.dbgmsg(0, "addplayerteam: Specified team with player model already exists. Cannot add.")

def delweaponclass(classname):
	if classname in classlist:
		if "world" in classlist[classname]:
			worldmodel = classlist[classname]["world"]
		if "view" in classlist[classname]:
			viewmodel = classlist[classname]["view"]
		del classlist[classname]
		if worldmodel and not checkallmodels(worldmodel):
			delmodeldownload(worldmodel)
		if viewmodel and not checkallmodels(viewmodel):
			delmodeldownload(viewmodel)			
	else:
		es.dbgmsg(0, "delweaponclass: Specified class does not exist. Cannot delete.")

def delweaponindex(index):
	if index in indexlist:
		if "world" in indexlist[index]:
			worldmodel = indexlist[index]["world"]
		if "view" in indexlist[index]:
			viewmodel = indexlist[index]["view"]
		del indexlist[index]
		if worldmodel and not checkallmodels(worldmodel):
			delmodeldownload(worldmodel)
		if viewmodel and not checkallmodels(viewmodel):
			delmodeldownload(viewmodel)
	else:
		es.dbgmsg(0, "delweaponindex: Specified index does not exist. Cannot delete.")

def delweaponuserid(userid,classname):
	if userid in useridlist:
		if classname in useridlist[userid]:
			if "world" in useridlist[userid][classname]:
				worldmodel = useridlist[userid][classname]["world"]
			if "view" in useridlist[userid][classname]:
				viewmodel = useridlist[userid][classname]["view"]
			del useridlist[userid][classname]
			if worldmodel and not checkallmodels(worldmodel):
				delmodeldownload(worldmodel)
			if viewmodel and not checkallmodels(viewmodel):
				delmodeldownload(viewmodel)
		else:
			es.dbgmsg(0, "delweaponuserid: Specified userid with classname does not exist. Cannot delete.")
	else:
		es.dbgmsg(0, "delweaponuserid: Specified userid does not exist. Cannot delete.")

def delweaponsteamid(steamid,classname):
	if steamid in steamidlist:
		if classname in steamidlist[steamid]:
			if "world" in steamidlist[steamid][classname]:
				worldmodel = steamidlist[steamid][classname]["world"]
			if "view" in steamidlist[steamid][classname]:
				viewmodel = steamidlist[steamid][classname]["view"]
			del steamidlist[steamid][classname]
			if worldmodel and not checkallmodels(worldmodel):
				delmodeldownload(worldmodel)
			if viewmodel and not checkallmodels(viewmodel):
				delmodeldownload(viewmodel)
			userid = int(es.getuserid(steamid))
			delweaponuserid(userid,classname)
		else:
			es.dbgmsg(0, "delweaponsteamid: Specified steamid with classname does not exist. Cannot delete.")
	else:
		es.dbgmsg(0, "delweaponsteamid: Specified steamid does not exist. Cannot delete.")

def delweaponteam(team,classname):
	if not team in resolveteams:
		es.dbgmsg(0, "delweaponteam: Invalid team specified '%s'"%team)
		return
	team = resolveteams[team]
	if team in teamlist:
		if classname in teamlist[team]:
			if "world" in teamlist[team][classname]:
				worldmodel = teamlist[team][classname]["world"]
			if "view" in teamlist[team][classname]:
				viewmodel = teamlist[team][classname]["view"]
			del teamlist[team][classname]
			if worldmodel and not checkallmodels(worldmodel):
				delmodeldownload(worldmodel)
			if viewmodel and not checkallmodels(viewmodel):
				delmodeldownload(viewmodel)
			for userid in es.getUseridList():
				if es.getplayerprop(userid, "CBaseEntity.m_iTeamNum") == team:
					delweaponuserid(userid,classname)
		else:
			es.dbgmsg(0, "delweaponteam: Specified team with classname does not exist. Cannot delete.")
	else:
		es.dbgmsg(0, "delweaponteam: Specified team does not exist. Cannot delete.")

def delplayeruserid(userid):
	if userid in useridlist:
		if "player" in useridlist[userid]:
			playermodel = useridlist[userid]["player"]
			del useridlist[userid]["player"]
			if not checkallmodels(playermodel):
				delmodeldownload(playermodel)
		else:
			es.dbgmsg(0, "delplayeruserid: Specified userid with player model does not exist. Cannot delete.")
	else:
		es.dbgmsg(0, "delplayeruserid: Specified userid does not exist. Cannot delete.")

def delplayersteamid(steamid):
	if steamid in steamidlist:
		if "player" in steamidlist[steamid]:
			playermodel = steamidlist[steamid]["player"]
			del steamidlist[steamid]["player"]
			if not checkallmodels(playermodel):
				delmodeldownload(playermodel)
			userid = int(es.getuserid(steamid))
			delplayeruserid(userid)
		else:
			es.dbgmsg(0, "delplayersteamid: Specified steamid with player model does not exist. Cannot delete.")
	else:
		es.dbgmsg(0, "delplayersteamid: Specified steamid does not exist. Cannot delete.")

def delplayerteam(team):
	if not team in resolveteams:
		es.dbgmsg(0, "delplayerteam: Invalid team specified '%s'"%team)
		return
	team = resolveteams[team]
	if team in teamlist:
		if "player" in teamlist[team]:
			playermodel = teamlist[team]["player"]
			del teamlist[team]["player"]
			if not checkallmodels(playermodel):
				delmodeldownload(playermodel)
			for userid in es.getUseridList():
				if es.getplayerprop(userid, "CBaseEntity.m_iTeamNum") == team:
					delplayeruserid(userid)
		else:
			es.dbgmsg(0, "delplayerteam: Specified team with player model does not exist. Cannot delete.")
	else:
		es.dbgmsg(0, "delplayerteam: Specified team does not exist. Cannot delete.")

def addmodeldownload(model):
	if model == -1 or model == "-1":
		return
	if model not in downloadlist:
		downloadlist[model] = True
	model = checkmodelstring(model)
	fileName = es.getAddonPath("modelchanger")
	fileName = fileName.replace("addons\eventscripts/modelchanger", "models\%s"%(model))
	fileName = fileName.replace("addons\eventscripts\modelchanger", "models\%s"%(model))
	if os.path.exists(fileName):
		downloadable(model)
	else:
		es.dbgmsg(0, "addmodeldownload: Specified model doesn't exist.")

def downloadable(model):
	modellib.addModelToDownloadables(model)

def delmodeldownload(model):
	if model in downloadlist:
		del downloadlist[model]

def checkallmodels(model):
	for classname in classlist:
		if "world" in classlist[classname]:
			if classlist[classname]["world"] == model:
				return True
		if "view" in classlist[classname]:
			if classlist[classname]["view"] == model:
				return True
	for index in indexlist:
		if "world" in indexlist[index]:
			if indexlist[index]["world"] == model:
				return True
		if "view" in indexlist[index]:
			if indexlist[index]["view"] == model:
				return True	
	for userid in useridlist:
		for classname in useridlist[userid]:
			if classname == "player":
				if useridlist[userid][classname] == model:
					return True
			if "world" in useridlist[userid][classname]:
				if useridlist[userid][classname]["world"] == model:
					return True
			if "view" in useridlist[userid][classname]:
				if useridlist[userid][classname]["view"]:
					return True
	for steamid in steamidlist:
		for classname in steamidlist[steamid]:
			if classname == "player":
				if steamidlist[steamid][classname] == model:
					return True
			if "world" in steamidlist[steamid][classname]:
				if steamidlist[steamid][classname]["world"] == model:
					return True
			if "view" in steamidlist[steamid][classname]:
				if steamidlist[steamid][classname]["view"]:
					return True
	for team in teamlist:
		for classname in teamlist[team]:
			if classname == "player":
				if teamlist[team][classname] == model:
					return True
			if "world" in teamlist[team][classname]:
				if teamlist[team][classname]["world"] == model:
					return True
			if "view" in teamlist[team][classname]:
				if teamlist[team][classname]["view"]:
					return True
	return False

def ticker():
	for userid in es.getUseridList():
		checkweapon(userid)
		checkteam(userid)
	if NadeModels:
		checkfornades()

def checkfornades():
	helist = es.createentitylist("hegrenade_projectile")
	flashlist = es.createentitylist("flashbang_projectile")
	smokelist = es.createentitylist("smokegrenade_projectile")
	for userid in useridlist:
		playerHandle = es.getplayerhandle(userid)
		if "hegrenade_projectile" in useridlist[userid]:
			for index in helist:
				owner = es.getindexprop(index,"CBaseEntity.m_hOwnerEntity")
				if playerHandle == owner:
					setEntityModel(index, useridlist[userid]["hegrenade_projectile"]["world"])
		if "flashbang_projectile" in useridlist[userid]:
			for index in flashlist:
				owner = es.getindexprop(index,"CBaseEntity.m_hOwnerEntity")
				if playerHandle == owner:
					setEntityModel(index, useridlist[userid]["flashbang_projectile"]["world"])
		if "smokegrenade_projectile" in useridlist[userid]:
			for index in smokelist:
				owner = es.getindexprop(index,"CBaseEntity.m_hOwnerEntity")
				if playerHandle == owner:
					setEntityModel(index, useridlist[userid]["smokegrenade_projectile"]["world"])
	if "hegrenade_projectile" in classlist:
		for index in helist:
			setEntityModel(index, classlist["hegrenade_projectile"]["world"])
	if "flashbang_projectile" in classlist:
		for index in flashlist:
			setEntityModel(index, classlist["flashbang_projectile"]["world"])
	if "smokegrenade_projectile" in classlist:
		for index in smokelist:
			setEntityModel(index, classlist["smokegrenade_projectile"]["world"])

def checkweapon(userid):
	global oldweps
	if userid not in oldweps:
		oldweps[userid] = {}
		oldweps[userid]["windex"] = -1
		oldweps[userid]["whandle"] = -1
		oldweps[userid]["wname"] = ""
	oldweapon = oldweps[userid]["whandle"]
	newweapon = es.getplayerprop(userid, "CBaseCombatCharacter.m_hActiveWeapon")
	if newweapon != oldweapon:
		classname = getactiveweaponname(userid)
		newwepindex = getweaponindex(userid,classname)
		oldindex = oldweps[userid]["windex"]
		oldclassname = oldweps[userid]["wname"]
		weapon_changed(userid,oldindex,newwepindex,oldclassname,classname)
		oldweps[userid]["whandle"] = newweapon
		oldweps[userid]["windex"] = newwepindex
		oldweps[userid]["wname"] = classname

def checkteam(userid):
	global oldteams
	if userid not in oldteams:
		oldteams[userid] = -1
	oldteam = oldteams[userid]
	newteam = es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	if newteam != oldteam:
		team_changed(userid,oldteam,newteam)
	oldteams[userid] = newteam

def weapon_changed(userid,oldindex,newindex,oldclass,newclass):
	if newclass in classlist:
		setActiveViewModel(userid, classlist[newclass]["view"])
		setWorldModel(newindex, classlist[newclass]["world"])
	elif newindex in indexlist:
		setActiveViewModel(userid, indexlist[newindex]["view"])
		setWorldModel(newindex, indexlist[newindex]["world"])
	elif userid in useridlist:
		if newclass in useridlist[userid]:
			setActiveViewModel(userid, useridlist[userid][newclass]["view"])
			setWorldModel(newindex, useridlist[userid][newclass]["world"])
		if WorldModelUserid and oldclass in useridlist[userid]:
			setWorldModel(oldindex, useridlist[userid][oldclass]["world"])
	if oldclass in classlist:
		setWorldModel(oldindex, classlist[oldclass]["world"])
	elif oldindex in indexlist:
		setWorldModel(oldindex, indexlist[oldindex]["world"])

def team_changed(userid,oldteam,newteam):
	if newteam in teamlist:
		for classname in teamlist[newteam]:
			if classname == "player":
				addplayeruserid(userid, teamlist[newteam][classname])
			if "view" in teamlist[newteam][classname] and "world" in teamlist[newteam][classname]:
				addweaponuserid(userid, classname, teamlist[newteam][classname]["world"], teamlist[newteam][classname]["view"])

def es_map_changed(ev):
	download_models()

def getactiveweaponname(userid):
	if not useridexists(userid) or isdead(userid):
		return ""
	plist = es.createplayerlist(userid)
	return plist[userid]["weapon"]

def getweaponindex(userid,weapon):
	if not useridexists(userid) or isdead(userid) or weapon == "":
		return -1
	myPlayer = playerlib.getPlayer(userid)
	return myPlayer.get("weaponindex",weapon)

def isdead(userid):
	if not useridexists(userid):
		return True
	plist = es.createplayerlist(userid)
	return not (plist[userid]["isdead"] == 0)

def download_models():
	for model in downloadlist:
		downloadable(model)

def indexexists(index):
	return (index in es.createentitylist(index) and index > 0)

def useridexists(userid):
	return (userid == es.getuserid(userid) and userid > 0)
